package com.its.op.service.its.vms;

import com.its.op.dao.repository.its.vms.TbVmsFormColrRepository;
import com.its.op.dto.its.vms.TbVmsFormColrDto;
import com.its.op.entity.its.vms.TbVmsFormColr;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsFormBckghueService {

    private final TbVmsFormColrRepository repo;

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVmsFormColrDto> findAll() {
        List<TbVmsFormColrDto> result = new ArrayList<>();
        List<TbVmsFormColr> data = this.repo.findAll();
        for (TbVmsFormColr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVmsFormColrDto> mergeInfoList(List<TbVmsFormColrDto.TbVmsFormColrUpdReq> reqList) {
        List<TbVmsFormColrDto> result = new ArrayList<>();
        for (TbVmsFormColrDto.TbVmsFormColrUpdReq req : reqList) {
            TbVmsFormColr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVmsFormColrDto mergeInfo(TbVmsFormColrDto.TbVmsFormColrUpdReq req) {
        TbVmsFormColr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVmsFormColrDto> deleteByIds(List<Long> ids) {
        List<TbVmsFormColrDto> result = new ArrayList<>();
        for (Long id : ids) {
            Optional<TbVmsFormColr> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
